LS={}

LS.Environment={}
LS.Suit={}
LS.Environmental={}
LS.Environmental.Control={}

function initArray2(f,v)
    local cmd = {}
    for c = 1, f do
    	cmd[c] = v
    end
    return cmd
end

function initArray3(f,x,v)
    local cmd = {}
    for c = 1, f do
    	cmd[c] = {x,v}
    end
    return cmd
end

dofile("sys/lua/lifesupport/"..game("sv_map")..".lua")

LS.TempMin=0
LS.FairTempMin=263
LS.FairTempMax=323
LS.TempMax=773

LS.FairO2Min=18

LS.Environment.O2=initArray2(32,20)
LS.Environment.Temp=initArray2(32,288)

LS.Suit.O2=initArray2(32,5)
LS.Suit.Coolant=initArray2(32,5)
LS.Suit.Energy=initArray2(32,5)

LS.Environment.Image=initArray2(32,0)

LS.Environment.IsShown=initArray2(32,false)

LS.Environmental.Control.MaxDevices=128
LS.Environmental.Control.CurrentDeviceID=1
LS.Environmental.Control.DevicePos=initArray3(32,{0,0})
LS.Environmental.Control.DeviceType=initArray2(32,0) -- 1 for light suit dispenser, 2 for large suit dispenser, 3 for oxygen battery, 4 for coolant battery, 5 for energy battery, 6 for N2 compressor, 7 for N2 storage, 8 for terraformer 
LS.Environmental.Control.DeviceState=initArray2(32,false)
LS.Environmental.Control.DeviceImage=initArray2(LS.Environmental.Control.MaxDevices,0)
LS.Environmental.Control.DeviceResources=initArray3(LS.Environmental.Control.MaxDevices,{0,0}) -- 1 for oxygen, 2 for coolant, 3 for energy, 4 for nitrogen
LS.Environmental.Control.Linked=initArray2(LS.Environmental.Control.MaxDevices,false)
LS.Environmental.Control.LinkedTo=initArray2(LS.Environmental.Control.MaxDevices,0)
LS.Environmental.Control.Exists=initArray2(LS.Environmental.Control.MaxDevices,false)
LS.Environmental.Control.IsReactor=initArray2(LS.Environmental.Control.MaxDevices,false)
LS.Environmental.Control.TerraformerZone=initArray2(LS.Environmental.Control.MaxDevices,0)

LS.Environment.PlanetZones=Zones[0].max
LS.Environment.CurrentZone=Zones[0].max+1

function ClientHUD(id,idt,color,text,x,y)
    local toprint=(""..color.." "..text)
    parse('hudtxt2 '..id..' '..idt..' "'..toprint..'" '..x.." "..y)
end

function LS.Environment.SuitDispenser(id,deviceid,o2,coolant,energy)
    if (LS.Environmental.Control.DeviceResources[deviceid][1]>=o2) then
        LS.Suit.O2[id]=LS.Suit.O2[id]+o2
        LS.Environmental.Control.DeviceResources[deviceid][1]=LS.Environmental.Control.DeviceResources[deviceid][1]-o2
        sound3(player(id,"tilex"),player(id,"tiley"),4,4,"space/air.wav")
    else
        msg2(id,"Not enough oxygen!")
    end
    if (LS.Environmental.Control.DeviceResources[deviceid][2]>=coolant) then
        LS.Suit.Coolant[id]=LS.Suit.Coolant[id]+coolant
        LS.Environmental.Control.DeviceResources[deviceid][2]=LS.Environmental.Control.DeviceResources[deviceid][2]-coolant
        sound3(player(id,"tilex"),player(id,"tiley"),4,4,"space/air.wav")
    else
        msg2(id,"Not enough coolant!")
    end
    if (LS.Environmental.Control.DeviceResources[deviceid][3]>=energy) then
        LS.Suit.Energy[id]=LS.Suit.Energy[id]+energy
        LS.Environmental.Control.DeviceResources[deviceid][3]=LS.Environmental.Control.DeviceResources[deviceid][3]-energy
        sound3(player(id,"tilex"),player(id,"tiley"),4,4,"space/air.wav")
    else
        msg2(id,"Not enough energy!")
    end
end

function sound3(tilex,tiley,rangex,rangey,sound)
    -- Ranges are tiles!
    for pl=1,32 do
        if (player(pl,"exists")) then
            if (player(pl,"tilex")>=tilex-rangex and player(pl,"tiley")>=tiley-rangey and player(pl,"tilex")<=tilex+rangex and player(pl,"tiley")<=tiley+rangey) then
                parse("sv_sound2 "..pl.." \""..sound.."\"")
            end
        end
    end
end

function LS.DevicesMenu(id)
    menu(id,"Devices Menu,Suit Dispenser (Light),Suit Dispenser (Large),Oxygen Injection Storage,Coolant Injection Storage,Energy Injection Storage,Nitrogen Compressor,Nitrogen Storage,Terraformer")
end

function LS.Environment.Control(id,temp,o2,mode)
    if (mode=="on") then
        if (LS.Environment.IsShown[id]==false) then
            LS.Environment.Image[id]=image("gfx/space/lstable.png",350,420,2,id)
            if (LS.Suit.O2[id]<5) then
                LS.Suit.O2[id]=5
            end
            if (LS.Suit.Coolant[id]<5) then
                LS.Suit.Coolant[id]=5
            end
            if (LS.Suit.Energy[id]<5) then
                LS.Suit.Energy[id]=5
            end
            LS.Environment.Temp[id]=temp
            LS.Environment.O2[id]=o2
            if LS.Environment.Temp[id]<LS.FairTempMin then
                ClientHUD(id,1,"000255255","Temperature: "..LS.Environment.Temp[id],290,375)
            elseif LS.Environment.Temp[id]>LS.FairTempMax then
                ClientHUD(id,1,"255000000","Temperature: "..LS.Environment.Temp[id],290,375)
            elseif LS.Environment.Temp[id]>LS.FairTempMin and LS.Environment.Temp[id]<LS.FairTempMax then
                ClientHUD(id,1,"255255255","Temperature: "..LS.Environment.Temp[id],290,375)
            end
            ClientHUD(id,2,"255255255","Oxygen: "..LS.Suit.O2[id].." ("..((LS.Suit.O2[id]/2.5)*10).."s)",290,400)
            ClientHUD(id,3,"255255255","Coolant: "..LS.Suit.Coolant[id].." ("..((LS.Suit.Coolant[id]/2.5)*10).."s)",290,415)
            ClientHUD(id,4,"255255255","Energy: "..LS.Suit.Energy[id].." ("..((LS.Suit.Energy[id]/2.5)*10).."s)",290,430)
            LS.Environment.IsShown[id]=true
            if LS.Environment.Temp[id]<LS.FairTempMin then
                LS.Suit.Energy[id]=LS.Suit.Energy[id]-0.25
            elseif LS.Environment.Temp[id]>LS.FairTempMax then
                LS.Suit.Coolant[id]=LS.Suit.Coolant[id]-0.25
            end
            if LS.Environment.O2[id]<LS.FairO2Min then
                LS.Suit.O2[id]=LS.Suit.O2[id]-0.25
            end
        end
    elseif (mode=="continue") then
            if LS.Environment.Temp[id]<LS.FairTempMin then
                ClientHUD(id,1,"000255255","Temperature: "..LS.Environment.Temp[id],290,375)
            elseif LS.Environment.Temp[id]>LS.FairTempMax then
                ClientHUD(id,1,"255000000","Temperature: "..LS.Environment.Temp[id],290,375)
            elseif LS.Environment.Temp[id]>LS.FairTempMin and LS.Environment.Temp[id]<LS.FairTempMax then
                ClientHUD(id,1,"255255255","Temperature: "..LS.Environment.Temp[id],290,375)
            end
            ClientHUD(id,2,"255255255","Oxygen: "..LS.Suit.O2[id].." ("..((LS.Suit.O2[id]/2.5)*10).."s)",290,400)
            ClientHUD(id,3,"255255255","Coolant: "..LS.Suit.Coolant[id].." ("..((LS.Suit.Coolant[id]/2.5)*10).."s)",290,415)
            ClientHUD(id,4,"255255255","Energy: "..LS.Suit.Energy[id].." ("..((LS.Suit.Energy[id]/2.5)*10).."s)",290,430)
            if LS.Environment.Temp[id]<LS.FairTempMin then
                LS.Suit.Energy[id]=LS.Suit.Energy[id]-0.25
                if LS.Suit.Energy[id]<=0 then
                    LS.Suit.Energy[id]=0
                end
            elseif LS.Environment.Temp[id]>LS.FairTempMax then
                LS.Suit.Coolant[id]=LS.Suit.Coolant[id]-0.25
                if LS.Suit.Coolant[id]<=0 then
                    LS.Suit.Coolant[id]=0
                end
            end
            if LS.Environment.O2[id]<LS.FairO2Min then
                LS.Suit.O2[id]=LS.Suit.O2[id]-0.25
                if LS.Suit.O2[id]<=0 then
                    LS.Suit.O2[id]=0
                end
            end
    elseif (mode=="airexchanger") then
        LS.Environment.Image[id]=image("gfx/space/lstable.png",350,420,2,id)
        LS.Suit.O2[id]=5
        if LS.Environment.Temp[id]<LS.FairTempMin then
            ClientHUD(id,1,"000255255","Temperature: "..LS.Environment.Temp[id],290,375)
        elseif LS.Environment.Temp[id]>LS.FairTempMax then
            ClientHUD(id,1,"255000000","Temperature: "..LS.Environment.Temp[id],290,375)
        elseif LS.Environment.Temp[id]>LS.FairTempMin and LS.Environment.Temp[id]<LS.FairTempMax then
            ClientHUD(id,1,"255255255","Temperature: "..LS.Environment.Temp[id],290,375)
        end
        ClientHUD(id,2,"255255255","Oxygen: "..LS.Suit.O2[id].." ("..((LS.Suit.O2[id]/2.5)*10).."s)",290,400)
        ClientHUD(id,3,"255255255","Coolant: "..LS.Suit.Coolant[id].." ("..((LS.Suit.Coolant[id]/2.5)*10).."s)",290,415)
        ClientHUD(id,4,"255255255","Energy: "..LS.Suit.Energy[id].." ("..((LS.Suit.Energy[id]/2.5)*10).."s)",290,430)
        if LS.Environment.O2[id]<LS.FairO2Min then
            if LS.Suit.O2[id]<=5 then
                LS.Suit.O2[id]=5
            end
        end
    elseif (mode=="off") then
        if (LS.Environment.IsShown[id]==true) then
            freeimage(LS.Environment.Image[id])
            LS.Environment.Image[id]=0
            if (LS.Suit.O2[id]<5) then
                LS.Suit.O2[id]=5
            end
            if (LS.Suit.Coolant[id]<5) then
                LS.Suit.Coolant[id]=5
            end
            if (LS.Suit.Energy[id]<5) then
                LS.Suit.Energy[id]=5
            end
            ClientHUD(id,1,"255255255"," ",0,0)
            ClientHUD(id,2,"255255255"," ",0,0)
            ClientHUD(id,3,"255255255"," ",0,0)
            ClientHUD(id,4,"255255255"," ",0,0)
            LS.Environment.IsShown[id]=false
        end
    end
end

addhook("serveraction","LS.Environment.ServerAction")
function LS.Environment.ServerAction(id,a)
    if (a==1) then
        LS.DevicesMenu(id)
    end
end

LS.Environmental.Control.DeviceStack=initArray2(32,0)
LS.Environmental.Control.LinkStack=initArray2(32,0)
LS.Environmental.Control.DeviceOwner=initArray2(LS.Environmental.Control.MaxDevices,0)
LS.Environmental.Control.IsBeingLinked=initArray2(32,false)
LS.Environmental.Control.IsBattery=initArray2(LS.Environmental.Control.MaxDevices,false)

function LS.Environmental.Control.AirExchangerMenu(id,deviceid,devicetype)
    if (LS.Environmental.Control.DeviceState[deviceid]~=true) then
        if (devicetype==1) then
            if (id==LS.Environmental.Control.DeviceOwner[deviceid]) then
                menu(id,"Suit Dispenser (Light),Surge,Overload,,Remove,"..LS.Environmental.Control.DeviceResources[deviceid][1].." O2,"..LS.Environmental.Control.DeviceResources[deviceid][2].." Coolant,"..LS.Environmental.Control.DeviceResources[deviceid][3].." Energy")
            else
                menu(id,"Suit Dispenser (Light),Surge,,,"..LS.Environmental.Control.DeviceResources[deviceid][1].." O2,"..LS.Environmental.Control.DeviceResources[deviceid][2].." Coolant,"..LS.Environmental.Control.DeviceResources[deviceid][3].." Energy")
            end
            if (LS.Environmental.Control.IsBeingLinked[id]) then
                menu(id,"Suit Dispenser (Light),,,Select this device")
            end
        elseif (devicetype==2) then
            if (id==LS.Environmental.Control.DeviceOwner[deviceid]) then
                menu(id,"Suit Dispenser (Large),Surge,Overload,,Remove,"..LS.Environmental.Control.DeviceResources[deviceid][1].." O2,"..LS.Environmental.Control.DeviceResources[deviceid][2].." Coolant,"..LS.Environmental.Control.DeviceResources[deviceid][3].." Energy")
            else
                menu(id,"Suit Dispenser (Large),Surge,,,"..LS.Environmental.Control.DeviceResources[deviceid][1].." O2,"..LS.Environmental.Control.DeviceResources[deviceid][2].." Coolant,"..LS.Environmental.Control.DeviceResources[deviceid][3].." Energy")
            end
            if (LS.Environmental.Control.IsBeingLinked[id]) then
                menu(id,"Suit Dispenser (Large),,,Select this device")
            end
        end
        LS.Environmental.Control.DeviceStack[id]=deviceid
    end
end

function LS.Environmental.Control.N2CompressorMenu(id,deviceid)
    if (id==LS.Environmental.Control.DeviceOwner[deviceid]) then
        if (LS.Environmental.Control.DeviceState[deviceid]==false) then
            if (LS.Environmental.Control.DeviceResources[deviceid][3]>=25) then
                menu(id,"Nitrogen Compressor,Turn On,Link To,Remove,"..LS.Environmental.Control.DeviceResources[deviceid][3].." Energy left")
            else
                menu(id,"Nitrogen Compressor,,Link To,Remove,"..LS.Environmental.Control.DeviceResources[deviceid][3].." Energy left")
            end
            if (LS.Environmental.Control.IsBeingLinked[id]) then
                if not (LS.Environmental.Control.DeviceState[deviceid]) then
                    menu(id,"Nitrogen Compressor,,,,"..LS.Environmental.Control.DeviceResources[deviceid][3].." Energy left,Select this device")
                end
            end
        end
        if (LS.Environmental.Control.DeviceState[deviceid]) then
            menu(id,"Nitrogen Compressor,Turn Off,,Remove,"..LS.Environmental.Control.DeviceResources[deviceid][3].." Energy left")
        end
    end
    LS.Environmental.Control.DeviceStack[id]=deviceid
end

function LS.Environmental.Control.TerraformerMenu(id,deviceid)
    if (id==LS.Environmental.Control.DeviceOwner[deviceid]) then
        if not (LS.Environmental.Control.DeviceState[deviceid]) then
            for res=1,4 do
                if (LS.Environmental.Control.DeviceResources[deviceid][res]>=1000) then
                    menu(id,"Terraformer,Terraform,Remove,,"..LS.Environmental.Control.DeviceResources[deviceid][1].." oxygen,"..LS.Environmental.Control.DeviceResources[deviceid][2].." coolant, "..LS.Environmental.Control.DeviceResources[deviceid][3].." energy,"..LS.Environmental.Control.DeviceResources[deviceid][4].." nitrogen")
                else
                    menu(id,"Terraformer,,Remove,,"..LS.Environmental.Control.DeviceResources[deviceid][1].." oxygen,"..LS.Environmental.Control.DeviceResources[deviceid][2].." coolant, "..LS.Environmental.Control.DeviceResources[deviceid][3].." energy,"..LS.Environmental.Control.DeviceResources[deviceid][4].." nitrogen")
                end
            end
        else
            menu(id,"Terraformer,,Remove,,"..LS.Environmental.Control.DeviceResources[deviceid][1].." oxygen,"..LS.Environmental.Control.DeviceResources[deviceid][2].." coolant, "..LS.Environmental.Control.DeviceResources[deviceid][3].." energy,"..LS.Environmental.Control.DeviceResources[deviceid][4].." nitrogen")
        end
        if (LS.Environmental.Control.IsBeingLinked[id]) then
            menu(id,"Terraformer,,,Select this device,"..LS.Environmental.Control.DeviceResources[deviceid][1].." oxygen,"..LS.Environmental.Control.DeviceResources[deviceid][2].." coolant, "..LS.Environmental.Control.DeviceResources[deviceid][3].." energy,"..LS.Environmental.Control.DeviceResources[deviceid][4].." nitrogen")
        end
    end
    LS.Environmental.Control.DeviceStack[id]=deviceid
end

addhook("menu","LS.Environment.Menus")
function LS.Environment.Menus(id,menu,sel)
    if (menu=="Devices Menu") then
        if (sel==1) then
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.CurrentDeviceID]=image("gfx/space/suit_dispenser_light.png",player(id,"x"),player(id,"y"),0)
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][1]=player(id,"tilex")
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][2]=player(id,"tiley")
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.CurrentDeviceID]=1
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.CurrentDeviceID]=id
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][1]=100
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][2]=100
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][3]=100
            LS.Environmental.Control.Exists[LS.Environmental.Control.CurrentDeviceID]=true
            LS.Environmental.Control.CurrentDeviceID=LS.Environmental.Control.CurrentDeviceID+1
            msg2(id,"A suit dispenser has been installed successfully!")
        end
        if (sel==2) then
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.CurrentDeviceID]=image("gfx/space/suit_dispenser_large.png",player(id,"x"),player(id,"y"),0)
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][1]=player(id,"tilex")
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][2]=player(id,"tiley")
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.CurrentDeviceID]=2
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.CurrentDeviceID]=id
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][1]=500
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][2]=500
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][3]=500
            LS.Environmental.Control.Exists[LS.Environmental.Control.CurrentDeviceID]=true
            LS.Environmental.Control.CurrentDeviceID=LS.Environmental.Control.CurrentDeviceID+1
            msg2(id,"A suit dispenser has been installed successfully!")
        end
        if (sel==3) then
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.CurrentDeviceID]=image("gfx/space/air_battery.png",player(id,"x"),player(id,"y"),0)
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][1]=player(id,"tilex")
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][2]=player(id,"tiley")
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.CurrentDeviceID]=3
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.CurrentDeviceID]=id
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][1]=200
            LS.Environmental.Control.Exists[LS.Environmental.Control.CurrentDeviceID]=true
            LS.Environmental.Control.CurrentDeviceID=LS.Environmental.Control.CurrentDeviceID+1
            msg2(id,"An oxygen injector has been installed successfully!")
        end
        if (sel==4) then
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.CurrentDeviceID]=image("gfx/space/coolant_battery.png",player(id,"x"),player(id,"y"),0)
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][1]=player(id,"tilex")
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][2]=player(id,"tiley")
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.CurrentDeviceID]=4
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.CurrentDeviceID]=id
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][2]=200
            LS.Environmental.Control.Exists[LS.Environmental.Control.CurrentDeviceID]=true
            LS.Environmental.Control.CurrentDeviceID=LS.Environmental.Control.CurrentDeviceID+1
            msg2(id,"A coolant injector has been installed successfully!")
        end
        if (sel==5) then
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.CurrentDeviceID]=image("gfx/space/energy_battery.png",player(id,"x"),player(id,"y"),0)
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][1]=player(id,"tilex")
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][2]=player(id,"tiley")
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.CurrentDeviceID]=5
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.CurrentDeviceID]=id
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][3]=200
            LS.Environmental.Control.Exists[LS.Environmental.Control.CurrentDeviceID]=true
            LS.Environmental.Control.CurrentDeviceID=LS.Environmental.Control.CurrentDeviceID+1
            msg2(id,"An energy injector has been installed successfully!")
        end
        if (sel==6) then
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.CurrentDeviceID]=image("gfx/space/n2_compressor.png",player(id,"x"),player(id,"y"),0)
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][1]=player(id,"tilex")
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][2]=player(id,"tiley")
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.CurrentDeviceID]=6
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.CurrentDeviceID]=id
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][3]=50
            LS.Environmental.Control.Exists[LS.Environmental.Control.CurrentDeviceID]=true
            LS.Environmental.Control.CurrentDeviceID=LS.Environmental.Control.CurrentDeviceID+1
            msg2(id,"A nitrogen compressor has been installed successfully!")
        end
        if (sel==7) then
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.CurrentDeviceID]=image("gfx/space/n2_storage.png",player(id,"x"),player(id,"y"),0)
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][1]=player(id,"tilex")
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][2]=player(id,"tiley")
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.CurrentDeviceID]=7
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.CurrentDeviceID]=id
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][4]=0
            LS.Environmental.Control.Exists[LS.Environmental.Control.CurrentDeviceID]=true
            LS.Environmental.Control.CurrentDeviceID=LS.Environmental.Control.CurrentDeviceID+1
            msg2(id,"A nitrogen storage has been installed successfully!")
        end
        if (sel==8) then
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.CurrentDeviceID]=image("gfx/space/terraformer.png",player(id,"x"),player(id,"y"),0)
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][1]=player(id,"tilex")
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.CurrentDeviceID][2]=player(id,"tiley")
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.CurrentDeviceID]=8
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.CurrentDeviceID]=id
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][1]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][2]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][3]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.CurrentDeviceID][4]=0
            LS.Environmental.Control.Exists[LS.Environmental.Control.CurrentDeviceID]=true
            LS.Environmental.Control.TerraformerZone[LS.Environmental.Control.CurrentDeviceID]=LS.Zone[id]
            LS.Environmental.Control.CurrentDeviceID=LS.Environmental.Control.CurrentDeviceID+1
            msg2(id,"A terraformer has been installed successfully!")
        end
    end
    if (menu=="Suit Dispenser (Light)") then
        if (sel==1) then
            LS.Environment.SuitDispenser(id,LS.Environmental.Control.DeviceStack[id],20,20,20)
        end
        if (sel==2) then
            LS.Environmental.Control.DeviceState[LS.Environmental.Control.DeviceStack[id]]=true
            local px=LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]*32+16
            local py=LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]*32+16
            timer(2000,"parse","explosion "..px.." "..py.." 256 200 "..id)
            sound3(LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1],LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2],4,4,"space/charge.wav")
            freeimage(LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]])
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.DeviceStack[id]]=0
        end
        if (sel==3) then
            LS.Environmental.Control.LinkedTo[LS.Environmental.Control.LinkStack[id]]=LS.Environmental.Control.DeviceStack[id]
            LS.Environmental.Control.Linked[LS.Environmental.Control.DeviceStack[id]]=true
            LS.Environmental.Control.Linked[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.IsBattery[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.DeviceState[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.IsBeingLinked[id]=false
            msg2(id,"Devices linked!")
        end
        if (sel==4) then
            freeimage(LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]])
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][3]=0
            LS.Environmental.Control.Exists[LS.Environmental.Control.DeviceStack[id]]=false
        end
    end
    if (menu=="Suit Dispenser (Large)") then
        if (sel==1) then
            LS.Environment.SuitDispenser(id,LS.Environmental.Control.DeviceStack[id],50,50,50)
        end
        if (sel==2) then
            LS.Environmental.Control.DeviceState[LS.Environmental.Control.DeviceStack[id]]=true
            local px=LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]*32+16
            local py=LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]*32+16
            timer(2000,"parse","explosion "..px.." "..py.." 512 500 "..id)
            sound3(LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1],LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2],4,4,"space/charge.wav")
            freeimage(LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]])
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.DeviceStack[id]]=0
        end
        if (sel==3) then
            LS.Environmental.Control.LinkedTo[LS.Environmental.Control.LinkStack[id]]=LS.Environmental.Control.DeviceStack[id]
            LS.Environmental.Control.Linked[LS.Environmental.Control.DeviceStack[id]]=true
            LS.Environmental.Control.Linked[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.IsBattery[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.DeviceState[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.IsBeingLinked[id]=false
            msg2(id,"Devices linked!")
        end
        if (sel==4) then
            freeimage(LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]])
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][3]=0
            LS.Environmental.Control.Exists[LS.Environmental.Control.DeviceStack[id]]=false
        end
    end
    if (menu=="Oxygen Battery Menu") then
        if (sel==1) then
            LS.Environmental.Control.IsBeingLinked[id]=true
            LS.Environmental.Control.LinkStack[id]=LS.Environmental.Control.DeviceStack[id]
            LS.Environmental.Control.IsBattery[LS.Environmental.Control.DeviceStack[id]]=true
            msg2(id,"Now select a device to link the battery to.")
        end
        if (sel==2) then
            freeimage(LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]])
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.Exists[LS.Environmental.Control.DeviceStack[id]]=false
        end
    elseif (menu=="Coolant Battery Menu") then
        if (sel==1) then
            LS.Environmental.Control.IsBeingLinked[id]=true
            LS.Environmental.Control.LinkStack[id]=LS.Environmental.Control.DeviceStack[id]
            LS.Environmental.Control.IsBattery[LS.Environmental.Control.DeviceStack[id]]=true
            msg2(id,"Now select a device to link the battery to.")
        end
        if (sel==2) then
            freeimage(LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]])
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.Exists[LS.Environmental.Control.DeviceStack[id]]=false
        end
    elseif (menu=="Energy Battery Menu") then
        if (sel==1) then
            LS.Environmental.Control.IsBeingLinked[id]=true
            LS.Environmental.Control.LinkStack[id]=LS.Environmental.Control.DeviceStack[id]
            LS.Environmental.Control.IsBattery[LS.Environmental.Control.DeviceStack[id]]=true
            msg2(id,"Now select a device to link the battery to.")
        end
        if (sel==2) then
            freeimage(LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]])
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][3]=0
            LS.Environmental.Control.Exists[LS.Environmental.Control.DeviceStack[id]]=false
        end
    elseif (menu=="Nitrogen Storage Menu") then
        if (sel==1) then
            LS.Environmental.Control.IsBeingLinked[id]=true
            LS.Environmental.Control.LinkStack[id]=LS.Environmental.Control.DeviceStack[id]
            LS.Environmental.Control.IsBattery[LS.Environmental.Control.DeviceStack[id]]=true
            msg2(id,"Now select a device to link the storage to.")
        end
        if (sel==2) then
            freeimage(LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]])
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][4]=0
            LS.Environmental.Control.Exists[LS.Environmental.Control.DeviceStack[id]]=false
        end
        if (sel==4) then
            LS.Environmental.Control.LinkedTo[LS.Environmental.Control.LinkStack[id]]=LS.Environmental.Control.DeviceStack[id]
            LS.Environmental.Control.Linked[LS.Environmental.Control.DeviceStack[id]]=true
            LS.Environmental.Control.Linked[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.IsReactor[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.DeviceState[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.IsBeingLinked[id]=false
            msg2(id,"Devices linked successfully!")
        end
    end
    if (menu=="Nitrogen Compressor") then
        if (sel==1) then
            if not (LS.Environmental.Control.DeviceState[LS.Environmental.Control.DeviceStack[id]]) then
                LS.Environmental.Control.DeviceState[LS.Environmental.Control.DeviceStack[id]]=true
                msg2(id,"Nitrogen compressor turned on!")
            else
                LS.Environmental.Control.DeviceState[LS.Environmental.Control.DeviceStack[id]]=false
                msg2(id,"Nitrogen compressor turned off!")
            end
        end
        if (sel==2) then
            LS.Environmental.Control.IsBeingLinked[id]=true
            LS.Environmental.Control.LinkStack[id]=LS.Environmental.Control.DeviceStack[id]
            LS.Environmental.Control.IsReactor[LS.Environmental.Control.DeviceStack[id]]=true
            msg2(id,"Now select a device to link the compressor to.")
        end
        if (sel==3) then
            freeimage(LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]])
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][3]=0
            LS.Environmental.Control.Exists[LS.Environmental.Control.DeviceStack[id]]=false
            LS.Environmental.Control.Linked[LS.Environmental.Control.DeviceStack[id]]=false
            LS.Environmental.Control.LinkedTo[LS.Environmental.Control.DeviceStack[id]]=false
            LS.Environmental.Control.IsReactor[LS.Environmental.Control.DeviceStack[id]]=false
        end
        if (sel==5) then
            LS.Environmental.Control.LinkedTo[LS.Environmental.Control.LinkStack[id]]=LS.Environmental.Control.DeviceStack[id]
            LS.Environmental.Control.Linked[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.IsBattery[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.DeviceState[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.IsBeingLinked[id]=false
            msg2(id,"Devices linked!")
        end
    end
    if (menu=="Terraformer") then
        if (sel==1) then
            if (LS.Environmental.Control.TerraformerZone[LS.Environmental.Control.DeviceStack[id]]~=Zones[0].max) then
                LS.Environmental.Control.DeviceState[LS.Environmental.Control.DeviceStack[id]]=true
                msg2(id,"Terraforming process started!")
                timer(120000,"parse","lua Zones["..LS.Environmental.Control.TerraformerZone[LS.Environmental.Control.DeviceStack[id]].."].O2=20")
                timer(120000,"parse","lua Zones["..LS.Environmental.Control.TerraformerZone[LS.Environmental.Control.DeviceStack[id]].."].Temp=288")
                timer(120000,"parse","lua Zones["..LS.Environmental.Control.TerraformerZone[LS.Environmental.Control.DeviceStack[id]].."].mode=\"off\"")
                for res=1,4 do
                    timer(120000,"parse","lua LS.Environmental.Control.DeviceResources["..LS.Environmental.Control.DeviceStack[id].."]["..res.."]=LS.Environmental.Control.DeviceResources["..LS.Environmental.Control.DeviceStack[id].."]["..res.."]-2000")
                end
                timer(120000,"mst",Zones[LS.Environmental.Control.TerraformerZone[LS.Environmental.Control.DeviceStack[id]]].name.." has been terraformed!@C")
                timer(120000,"parse","lua "..LS.Environmental.Control.TerraformerZone[LS.Environmental.Control.DeviceStack[id]].."=0")
            else
                msg2(id,"You can't terraform space! Don't be stupid!")
            end
        end
        if (sel==2) then
            freeimage(LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]])
            LS.Environmental.Control.DeviceImage[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DevicePos[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceType[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceOwner[LS.Environmental.Control.DeviceStack[id]]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][1]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][2]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][3]=0
            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.DeviceStack[id]][4]=0
            LS.Environmental.Control.Exists[LS.Environmental.Control.DeviceStack[id]]=false
            LS.Environmental.Control.Linked[LS.Environmental.Control.DeviceStack[id]]=false
            LS.Environmental.Control.LinkedTo[LS.Environmental.Control.DeviceStack[id]]=false
            LS.Environmental.Control.IsReactor[LS.Environmental.Control.DeviceStack[id]]=false
        end
        if (sel==3) then
            LS.Environmental.Control.LinkedTo[LS.Environmental.Control.LinkStack[id]]=LS.Environmental.Control.DeviceStack[id]
            LS.Environmental.Control.Linked[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.IsBattery[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.DeviceState[LS.Environmental.Control.LinkStack[id]]=true
            LS.Environmental.Control.IsBeingLinked[id]=false
            msg2(id,"Devices linked!")
        end
    end
end

function LS.Environmental.Control.N2StorageMenu(id,deviceid)
    if (id==LS.Environmental.Control.DeviceOwner[deviceid]) then
        if (LS.Environmental.Control.DeviceState[deviceid]==false) then
            if (LS.Environmental.Control.IsBeingLinked[id]) then
                menu(id,"Nitrogen Storage Menu,,,,Select this device")
            else
                menu(id,"Nitrogen Storage Menu,Link To,Remove,There is "..LS.Environmental.Control.DeviceResources[deviceid][4].." nitrogen")
            end
            LS.Environmental.Control.DeviceStack[id]=deviceid
        else
            menu(id,"Nitrogen Storage Menu,,Remove,There is "..LS.Environmental.Control.DeviceResources[deviceid][4].." nitrogen")
            LS.Environmental.Control.DeviceStack[id]=deviceid
        end
    end
end

function LS.Environmental.Control.BatteryMenu(id,deviceid)
    if (LS.Environmental.Control.DeviceType[deviceid]==3) then
        if (LS.Environmental.Control.DeviceState[deviceid]==false) then
            menu(id,"Oxygen Battery Menu,Link To,Remove")
            LS.Environmental.Control.DeviceStack[id]=deviceid
        else
            menu(id,"Oxygen Battery Menu,,Remove,There is "..LS.Environmental.Control.DeviceResources[deviceid][1].." oxygen left")
            LS.Environmental.Control.DeviceStack[id]=deviceid
        end
    elseif (LS.Environmental.Control.DeviceType[deviceid]==4) then
        if (LS.Environmental.Control.DeviceState[deviceid]==false) then
            menu(id,"Coolant Battery Menu,Link To,Remove")
            LS.Environmental.Control.DeviceStack[id]=deviceid
        else
            menu(id,"Coolant Battery Menu,,Remove,There is "..LS.Environmental.Control.DeviceResources[deviceid][2].." coolant left")
            LS.Environmental.Control.DeviceStack[id]=deviceid
        end
    elseif (LS.Environmental.Control.DeviceType[deviceid]==5) then
        if (LS.Environmental.Control.DeviceState[deviceid]==false) then
            menu(id,"Energy Battery Menu,Link To,Remove")
            LS.Environmental.Control.DeviceStack[id]=deviceid
        else
            menu(id,"Energy Battery Menu,,Remove,There is "..LS.Environmental.Control.DeviceResources[deviceid][3].." energy left")
            LS.Environmental.Control.DeviceStack[id]=deviceid
        end
    end
end

addhook("use","LS.Environment.Devices")
function LS.Environment.Devices(id,e,d,x,y)
    for DeviceID=1,LS.Environmental.Control.CurrentDeviceID do
        if (player(id,"tilex")==LS.Environmental.Control.DevicePos[DeviceID][1] and player(id,"tiley")==LS.Environmental.Control.DevicePos[DeviceID][2]) then
            if (LS.Environmental.Control.DeviceType[DeviceID]==1) then
                LS.Environmental.Control.AirExchangerMenu(id,DeviceID,1)
            elseif (LS.Environmental.Control.DeviceType[DeviceID]==2) then
                LS.Environmental.Control.AirExchangerMenu(id,DeviceID,2)
            elseif (LS.Environmental.Control.DeviceType[DeviceID]>=3 and LS.Environmental.Control.DeviceType[DeviceID]<=5) then
                LS.Environmental.Control.BatteryMenu(id,DeviceID)
            elseif (LS.Environmental.Control.DeviceType[DeviceID]==6) then
                LS.Environmental.Control.N2CompressorMenu(id,DeviceID)
            elseif (LS.Environmental.Control.DeviceType[DeviceID]==7) then
                LS.Environmental.Control.N2StorageMenu(id,DeviceID)
            elseif (LS.Environmental.Control.DeviceType[DeviceID]==8) then
                LS.Environmental.Control.TerraformerMenu(id,DeviceID)
            end
        end
    end
end

addhook("movetile","LS.Environment.State")
function LS.Environment.State(id,x,y)
    for zone=1,Zones[0].max do
        if (x>=Zones[zone].X1 and y>=Zones[zone].Y1 and x<=Zones[zone].X2 and y<=Zones[zone].Y2) then
            LS.Environment.Temp[id]=Zones[LS.Zone[id]].Temp
            LS.Environment.O2[id]=Zones[LS.Zone[id]].O2
            LS.Environment.Control(id,Zones[LS.Zone[id]].Temp,Zones[LS.Zone[id]].O2,Zones[LS.Zone[id]].mode)
        end
    end
    if (Zones[LS.Zone[id]].O2>=18 and Zones[LS.Zone[id]].Temp>=263 and Zones[LS.Zone[id]].Temp<=323) then
        LS.Environment.Control(id,Zones[LS.Zone[id]].Temp,Zones[LS.Zone[id]].O2,Zones[LS.Zone[id]].mode)
    end
end

addhook("die","LS.Environment.Death")
function LS.Environment.Death(id)
    LS.Environment.Control(id,0,0,"off")
    LS.Suit.O2[id]=5
    LS.Suit.Coolant[id]=5
    LS.Suit.Energy[id]=5
end

addhook("spawn","LS.Environment.Spawn")
function LS.Environment.Spawn(id)
    LS.Environment.Control(id,0,0,"off")
    LS.Environment.O2[id]=Zones[LS.Zone[id]].O2
    LS.Environment.Temp[id]=Zones[LS.Zone[id]].Temp
end

addhook("second","LS.Environment.Second")
function LS.Environment.Second()
    for id=1,32 do
        if LS.Environment.IsShown[id]==true then
            LS.Environment.Control(id,LS.Environment.Temp[id],LS.Environment.O2[id],"continue")
            if LS.Suit.O2[id]==0 or LS.Suit.Coolant[id]==0 or LS.Suit.Energy[id]==0 then
                parse("sethealth "..id.." "..(player(id,"health")-10))
            end
        end
        for device=1,LS.Environmental.Control.CurrentDeviceID do
            if (LS.Environmental.Control.Exists[device]) then
                if (LS.Environmental.Control.Linked[device]) then
                    if (LS.Environmental.Control.IsBattery[device]) then
                        if (LS.Environmental.Control.DeviceType[device]==3) then
                            if (LS.Environmental.Control.DeviceResources[device][1]>=10) then
                                LS.Environmental.Control.DeviceResources[device][1]=LS.Environmental.Control.DeviceResources[device][1]-10
                                LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][1]=LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][1]+10
                                sound3(LS.Environmental.Control.DevicePos[device][1],LS.Environmental.Control.DevicePos[device][2],4,4,"space/pump.wav")
                            end
                        elseif (LS.Environmental.Control.DeviceType[device]==4) then
                            if (LS.Environmental.Control.DeviceResources[device][2]>=10) then
                                LS.Environmental.Control.DeviceResources[device][2]=LS.Environmental.Control.DeviceResources[device][2]-10
                                LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][2]=LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][2]+10
                                sound3(LS.Environmental.Control.DevicePos[device][1],LS.Environmental.Control.DevicePos[device][2],4,4,"space/pump.wav")
                            end
                        elseif (LS.Environmental.Control.DeviceType[device]==5) then
                            if (LS.Environmental.Control.DeviceResources[device][3]>=10) then
                                LS.Environmental.Control.DeviceResources[device][3]=LS.Environmental.Control.DeviceResources[device][3]-10
                                LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][3]=LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][3]+10
                                sound3(LS.Environmental.Control.DevicePos[device][1],LS.Environmental.Control.DevicePos[device][2],4,4,"space/pump.wav")
                            end
                        elseif (LS.Environmental.Control.DeviceType[device]==7) then
                            if (LS.Environmental.Control.DeviceResources[device][4]>=10) then
                                LS.Environmental.Control.DeviceResources[device][4]=LS.Environmental.Control.DeviceResources[device][4]-10
                                LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][4]=LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][4]+10
                                sound3(LS.Environmental.Control.DevicePos[device][1],LS.Environmental.Control.DevicePos[device][2],4,4,"space/pump.wav")
                            end
                        end
                    end
                    if (LS.Environmental.Control.IsReactor[device]) then
                        if (LS.Environmental.Control.DeviceType[device]==6) then
                            if (LS.Environmental.Control.DeviceType[LS.Environmental.Control.LinkedTo[device]]==7) then
                                if (LS.Environmental.Control.DeviceState[device]==true) then
                                    if (LS.Environmental.Control.DeviceResources[device][3]>=25) then
                                        if (LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][4]<=1000) then
                                            LS.Environmental.Control.DeviceResources[device][3]=LS.Environmental.Control.DeviceResources[device][3]-25
                                            LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][4]=LS.Environmental.Control.DeviceResources[LS.Environmental.Control.LinkedTo[device]][4]+10
                                            sound3(LS.Environmental.Control.DevicePos[device][1],LS.Environmental.Control.DevicePos[device][2],4,4,"space/pump.wav")
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end